      REAL FUNCTION SF42R(F,N1,N2,IERR)
      INTEGER N1,N2,IERR,I1,I2,L2,I2P,I,NMAX,NMAX1
      REAL F,F1,F2,DP,SYS015,BIG,VP,CBR2,S,SF35R,DPL,
     1THETA,X3,F1F,F2P,X1,X2,CBR1,STS,A,B,XI,C,SYS059,
     1SYS029,SYS037,EXP,ALOG,SQRT,ATAN
      DATA  NMAX/20000/,BIG/1.E13/,NMAX1/20000/,SYS015/
     10.6366198/,SYS059/3.4E38/,SYS029/0.7071068/,SYS037/
     10.3333333/
      IF(N1.LT.1.OR.N2.LT.1.OR.N1+N2.GT.NMAX) GO TO 20
      IF(F.LT.0.0) GO TO 21
      IERR=0
      IF(F.EQ.0.0) GO TO 23
      F1=N1
      F2=N2
      DP=0.0
      VP=F1+F2-2.0
      F1F=F1*F
      F2P=F2+F1F
      X1=F2/F2P
      X2=1.0-X1
      IF(X2.EQ.0.0) GO TO 23
      IF((N1/2)*2-N1.EQ.0.AND.N1.LE.NMAX1) GO TO 1
      IF((N2/2)*2-N2.EQ.0.AND.N2.LE.NMAX1) GO TO 6
      IF(N1+N2.LE.NMAX1) GO TO 11
      F1=.2222222/F1
      F2=.2222222/F2
      CBR1=SYS037*ALOG(F)
      CBR1=EXP(CBR1)
      CBR2=CBR1*CBR1
      S=(CBR1*(1.0-F2)-1.0+F1)/SQRT(F1+CBR2*F2)
      SF42R=.5*SF35R(-SYS029*S)
      GO TO 25
    1 IF(N1.EQ.2) GO TO 5
      I1=N1-2
      DO 2 I2=2,I1,2
      L2=I2
      I=N1-I2
      VP=VP-2.
      DP=X2*VP/I*(1.+DP)
      IF(DP.GT.BIG) GO TO 3
    2 CONTINUE
      GO TO 5
    3 IF(L2.GE.I1) GO TO 5
      DPL=ALOG(DP)
      I2P=L2+2
      DO 4 I2=I2P,I1,2
      I=N1-I2
      VP=VP-2.
      DPL=DPL+ALOG(X2*VP/I)
    4 CONTINUE
      X3=1.-EXP(.5*F2*ALOG(X1)+DPL)
      SF42R=X3
      GO TO 19
    5 X2=EXP(0.5*F2*ALOG(X1))
      X3=1.0-X2*(1.0+DP)
      SF42R=X3
      GO TO 19
    6 IF(N2.EQ.2) GO TO 10
      I1=N2-2
      DO 7 I2=2,I1,2
      L2=I2
      I=N2-I2
      VP=VP-2.
      DP=X1*VP/I*(1.+DP)
      IF(DP.GT.BIG) GO TO 8
    7 CONTINUE
      GO TO 10
    8 IF(L2.GE.I1) GO TO 10
      DPL=ALOG(DP)
      I2P=L2+2
      DO 9 I2=I2P,I1,2
      I=N2-I2
      VP=VP-2.
      DPL=DPL+ALOG(X1*VP/I)
    9 CONTINUE
      X3=EXP(.5*F1*ALOG(X2)+DPL)
      SF42R=X3
      GO TO 19
   10 X2=EXP(.5*F1*ALOG(X2))
      X3=X2*(1.+DP)
      SF42R=X3
      GO TO 19
   11 DP=SQRT(F1F/F2)
      THETA=ATAN(DP)
      STS=F1F/F2P
      A=0.0
      B=0.0
      IF(N2.EQ.1) GO TO 14
      IF(N2.EQ.3) GO TO 13
      I1=N2-3
      DO 12 I2=2,I1,2
      XI=F2-I2
      A=X1*(XI-1.0)/XI*(1.0+A)
   12 CONTINUE
   13 A=X1*DP*(1.0+A)
   14 A=A+THETA
      IF(N1.EQ.1) GO TO 18
      IF(N1.EQ.3) GO TO 16
      I1=N1-3
      DO 15 I2=2,I1,2
      XI=F1-I2
      VP=VP-2.
      B=STS*VP/XI*(1.0+B)
   15 CONTINUE
   16 B=DP*X1*(1.0+B)
      IF(N2.EQ.1) GO TO 18
      I2=N2/2
      C=1.0
      DO 17 I=1,I2
      B=B*X1*C/(C-0.5)
      C=C+1.0
   17 CONTINUE
   18 X3=SYS015*(A-B)
      SF42R=X3
   19 IF(X3.LT.0.0) SF42R=0.0
      GO TO 25
   20 IERR=65
      GO TO 22
   21 IERR=66
   22 SF42R=SYS059
      GO TO 24
   23 SF42R=0.0
      GO TO 25
   24 CONTINUE
      CALL UTSF12(IERR,42)
   25 RETURN
      END
